site/apps/products/urls.py
from django.urls import path
from . import views

app_name = 'products'

urlpatterns = [
    path('', views.product_list, name='product_list'),
    path('<int:id>/<slug:slug>/', views.product_list,
         name='product_list_by_category'),
    path('<int:id>/<slug:slug>/', views.product_detail,
         name='product_detail'),
]

site/base/urls.py
"""site URL Configuration"""

from django.conf.urls import include, handler404, \
    handler500, handler403, handler400
from django.urls import path
from django.conf import settings
from django.conf.urls.i18n import i18n_patterns
from django.conf.urls.static import static
from django.contrib import admin
admin.autodiscover()

from apps.pages.views import ErrorPageView


urlpatterns = i18n_patterns(
    path('admin/', admin.site.urls),
    path('clothes/', include('apps.clothes.urls')),
    path('products/', include('apps.products.urls', namespace='products')),
    path('childcarts/', include('apps.childcarts.urls', namespace='childcarts')),
    path('', include('apps.pages.urls')),
)

if settings.DEBUG:
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

# views to display the corresponding error pages
handler404 = ErrorPageView.as_view(error_code='404')
handler403 = ErrorPageView.as_view(error_code='403')
handler400 = ErrorPageView.as_view(error_code='400')
handler500 = ErrorPageView.as_view(error_code='500')

site/apps/products/models.py
from django.db import models
from django.urls import reverse

from apps.brands.models import Brand


class Category(models.Model):
    name = models.CharField(max_length=200,
                            db_index=True)
    slug = models.SlugField(max_length=200)
    description = models.TextField(default='')
    # Any existing Category instance can be a parent_category.
    # To find all of the subcategories of a given Category
    # subcats = Category.objects.filter(parent_category__id=target_category.id)
    parent_category = models.ForeignKey(
        'self',
        null=True,
        blank=True,
        on_delete=models.SET_NULL)

    class Meta:
        #Two categories under a parent cannot have same slug
        unique_together = ('slug', 'parent_category',)
        ordering = ('name',)
        verbose_name = 'category'
        verbose_name_plural = 'categories'

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        # all_slugs = [self.slug]
        # import pdb; pdb.set_trace()
        # if self.parent_category:
        #     all_slugs.append(self.parent_category.slug)
        # all_slugs = [self.slug]
        # p = self.parent_category
        # while p:
        #     all_slugs.append(p.slug)
        #     p = p.parent_category
        # FIXME: If this is called from products/clothes/toys
        # TODO: etc view then return corresponding results
        return reverse('products:product_list_by_category',
                       args=[self.id, self.slug])


class Product(models.Model):
    name = models.CharField(max_length=200, db_index=True)
    slug = models.SlugField(max_length=200, db_index=True)
    image = models.ImageField(upload_to='products/%Y/%m/%d',
                              blank=True)
    description = models.TextField(blank=True)
    price = models.DecimalField(max_digits=10, decimal_places=2)
    available = models.BooleanField(default=True)
    created = models.DateTimeField(auto_now_add=True)
    updated = models.DateTimeField(auto_now=True)
    category = models.ForeignKey(Category,
                                 related_name='products',
                                 null=True,
                                 on_delete=models.SET_NULL)
    brand = models.ForeignKey(Brand,
                              blank=True,
                              null=True,
                              related_name='products',
                              on_delete=models.SET_NULL,)

    class Meta:
        ordering = ('name',)
        index_together = (('id', 'slug'),)

    def __str__(self):
        return self.name

    def get_absolute_url(self):
            return reverse('products:product_detail',
                           args=[self.id, self.slug])

site/apps/products/views.py
from django.shortcuts import render, get_object_or_404
from .models import Category, Product
# from cart.forms import CartAddProductForm


def product_list(request, id=None, slug=None, parent_slug=None):
    category = None
    categories = Category.objects.all()
    products = Product.objects.filter(available=True)
    if slug and id:
        category = Category.objects.filter(slug=slug, id=id)
    elif slug and parent_slug:
        # TODO if a category if deleted and the product still has
        # this category then we will get into problem here
        # category = get_object_or_404(Category, slug=category_slug)
        category = Category.objects.filter(slug=slug,
                                           parent_category__slug=parent_slug)
    # elif slug:
    #         category = Category.objects.filter(slug=slug)

    if category:
            products = products.filter(category__in=category)
    return render(request,
                  'products/list.html',
                  {
                      'category': category,
                      'categories': categories,
                      'products': products
                  }
                  )


def product_detail(request, id, slug):
    product = get_object_or_404(Product,
                                id=id,
                                slug=slug,
                                available=True)
    # cart_product_form = CartAddProductForm()
    return render(request,
                  'products/detail.html',
                  {
                      'product': product,
                      # 'cart_product_form': cart_product_form
                  }
                  )

site/templates/products/detail.html
{% extends "home_base.html" %}
{% load static %}

{% block title %}
  {{ product.name }}
{% endblock %}

{% block content %}
  <div class="product-detail">
    <img src="{% if product.image %}{{ product.image.url }}{% else %}{% static 'images/no_image.png' %}{% endif %}">
    <h1>{{ product.name }}</h1>
    <h2><a href="{{ product.category.get_absolute_url }}">{{ product.category }}</a></h2>
    <p class="price">${{ product.price }}</p>
    {{ product.description|linebreaks }}
  </div>
{% endblock %}

site/templates/products/list.html
{% extends "home_base.html" %}
{% load static %}

{% block title %}
  {% if category %}{{ category.name }}{% else %}Products{% endif %}
{% endblock %}

{% block content %}
<div class="row">
  <div class="col-sm-12">
    <h1>{% if category %}{{ category.name }}{% else %}Products{% endif %}</h1>
  </div>
  <div id="sidebar" class="col-sm-3">
    <h3>Categories</h3>
    <ul>
      <li {% if not category %}class="selected"{% endif %}>
        <a href="{% url 'products:product_list' %}">All</a>
      </li>
      {% for c in categories %}
        <li {% if category.slug == c.slug %}class="selected"{% endif %}>
          <a href="{{ c.get_absolute_url }}">{{ c.name }}</a>
        </li>
      {% endfor %}
    </ul>
  </div>
  <!--<div id="main" class="product-list row">-->
    <!--<h1>{% if category %}{{ category.name }}{% else %}Products{% endif %}</h1>-->
  {% if products %}
  {% for product in products %}
    <div class="item col-sm-3">
      <a href="{{ product.get_absolute_url }}">
        <img class="img-fluid" src="{% if product.image %}{{ product.image.url }}{% else %}
        {% static 'img/no_image.png' %}{% endif %}">
      </a>
      <a href="{{ product.get_absolute_url }}">{{ product.name }}</a><br>
      ${{ product.price }}
    </div>
  {% endfor %}
  {% endif %}
</div>
{% endblock %}